Index: kernel/genarch/include/ofw/ofw_tree.h
===================================================================
--- kernel/genarch/include/ofw/ofw_tree.h	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ kernel/genarch/include/ofw/ofw_tree.h	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -31,23 +31,26 @@
 
 #include <arch/types.h>
-#include <ddi/irq.h>
 #include <typedefs.h>
 
-#define OFW_TREE_PROPERTY_MAX_NAMELEN	32
+#define OFW_TREE_PROPERTY_MAX_NAMELEN  32
 
-typedef struct ofw_tree_node ofw_tree_node_t;
-typedef struct ofw_tree_property ofw_tree_property_t;
+/** Memory representation of OpenFirmware device tree node property. */
+typedef struct {
+	char name[OFW_TREE_PROPERTY_MAX_NAMELEN];
+	size_t size;
+	void *value;
+} ofw_tree_property_t;
 
 /** Memory representation of OpenFirmware device tree node. */
-struct ofw_tree_node {
-	ofw_tree_node_t *parent;
-	ofw_tree_node_t *peer;
-	ofw_tree_node_t *child;
-
-	uint32_t node_handle;		/**< Old OpenFirmware node handle. */
-
-	char *da_name;			/**< Disambigued name. */
-
-	unsigned properties;		/**< Number of properties. */
+typedef struct ofw_tree_node {
+	struct ofw_tree_node *parent;
+	struct ofw_tree_node *peer;
+	struct ofw_tree_node *child;
+	
+	uint32_t node_handle;           /**< Old OpenFirmware node handle. */
+	
+	char *da_name;                  /**< Disambigued name. */
+	
+	unsigned int properties;        /**< Number of properties. */
 	ofw_tree_property_t *property;
 	
@@ -57,147 +60,29 @@
 	 */
 	void *device;
-};
+} ofw_tree_node_t;
 
-/** Memory representation of OpenFirmware device tree node property. */
-struct ofw_tree_property {
-	char name[OFW_TREE_PROPERTY_MAX_NAMELEN];
-	size_t size;
-	void *value;
-};
-
-/*
- * Definition of 'reg' and 'ranges' properties for various buses.
- */
- 
-struct ofw_fhc_reg {
-	uint64_t addr;
-	uint32_t size;
-} __attribute__ ((packed));
-typedef struct ofw_fhc_reg ofw_fhc_reg_t;
-			
-struct ofw_fhc_range {
-	uint64_t child_base;
-	uint64_t parent_base;
-	uint32_t size;
-} __attribute__ ((packed));
-typedef struct ofw_fhc_range ofw_fhc_range_t;
-
-struct ofw_central_reg {
-	uint64_t addr;
-	uint32_t size;
-} __attribute__ ((packed));
-typedef struct ofw_central_reg ofw_central_reg_t;
-
-struct ofw_central_range {
-	uint64_t child_base;
-	uint64_t parent_base;
-	uint32_t size;
-} __attribute__ ((packed));
-typedef struct ofw_central_range ofw_central_range_t;
-
-struct ofw_ebus_reg {
-	uint32_t space;
-	uint32_t addr;
-	uint32_t size;
-} __attribute__ ((packed));
-typedef struct ofw_ebus_reg ofw_ebus_reg_t;
-
-struct ofw_ebus_range {
-	uint32_t child_space;
-	uint32_t child_base;
-	uint32_t parent_space;
-	uint64_t parent_base;	/* group phys.mid and phys.lo together */
-	uint32_t size;
-} __attribute__ ((packed));
-typedef struct ofw_ebus_range ofw_ebus_range_t;
-
-struct ofw_ebus_intr_map {
-	uint32_t space;
-	uint32_t addr;
-	uint32_t intr;
-	uint32_t controller_handle;
-	uint32_t controller_ino;
-} __attribute__ ((packed));
-typedef struct ofw_ebus_intr_map ofw_ebus_intr_map_t;
-
-struct ofw_ebus_intr_mask {
-	uint32_t space_mask;
-	uint32_t addr_mask;
-	uint32_t intr_mask;
-} __attribute__ ((packed));
-typedef struct ofw_ebus_intr_mask ofw_ebus_intr_mask_t;
-
-struct ofw_pci_reg {
-	uint32_t space;		/* needs to be masked to obtain pure space id */
-	uint64_t addr;		/* group phys.mid and phys.lo together */
-	uint64_t size;
-} __attribute__ ((packed));
-typedef struct ofw_pci_reg ofw_pci_reg_t;
-
-struct ofw_pci_range {
-	uint32_t space;
-	uint64_t child_base;	/* group phys.mid and phys.lo together */
-	uint64_t parent_base;
-	uint64_t size;
-} __attribute__ ((packed));
-typedef struct ofw_pci_range ofw_pci_range_t;
-
-struct ofw_sbus_reg {
-	uint64_t addr;
-	uint32_t size;
-} __attribute__ ((packed));
-typedef struct ofw_sbus_reg ofw_sbus_reg_t;
-
-struct ofw_sbus_range {
-	uint64_t child_base;
-	uint64_t parent_base;
-	uint32_t size;
-} __attribute__ ((packed));
-typedef struct ofw_sbus_range ofw_sbus_range_t;
-
-struct ofw_upa_reg {
-	uint64_t addr;
-	uint64_t size;
-} __attribute__ ((packed));
-typedef struct ofw_upa_reg ofw_upa_reg_t;
+/* Walker for visiting OpenFirmware device tree nodes. */
+typedef bool (* ofw_tree_walker_t)(ofw_tree_node_t *, void *);
 
 extern void ofw_tree_init(ofw_tree_node_t *);
 extern void ofw_tree_print(void);
+
 extern const char *ofw_tree_node_name(const ofw_tree_node_t *);
 extern ofw_tree_node_t *ofw_tree_lookup(const char *);
 extern ofw_tree_property_t *ofw_tree_getprop(const ofw_tree_node_t *,
     const char *);
+extern void ofw_tree_walk_by_device_type(const char *, ofw_tree_walker_t,
+    void *);
+
 extern ofw_tree_node_t *ofw_tree_find_child(ofw_tree_node_t *, const char *);
 extern ofw_tree_node_t *ofw_tree_find_child_by_device_type(ofw_tree_node_t *,
     const char *);
+
 extern ofw_tree_node_t *ofw_tree_find_peer_by_device_type(ofw_tree_node_t *,
     const char *);
-extern ofw_tree_node_t *ofw_tree_find_peer_by_name(ofw_tree_node_t *node,
-    const char *name);
+extern ofw_tree_node_t *ofw_tree_find_peer_by_name(ofw_tree_node_t *,
+    const char *);
 extern ofw_tree_node_t *ofw_tree_find_node_by_handle(ofw_tree_node_t *,
     uint32_t);
 
-extern bool ofw_fhc_apply_ranges(ofw_tree_node_t *, ofw_fhc_reg_t *,
-    uintptr_t *);
-extern bool ofw_central_apply_ranges(ofw_tree_node_t *, ofw_central_reg_t *,
-    uintptr_t *);
-extern bool ofw_ebus_apply_ranges(ofw_tree_node_t *, ofw_ebus_reg_t *,
-    uintptr_t *);
-extern bool ofw_pci_apply_ranges(ofw_tree_node_t *, ofw_pci_reg_t *,
-    uintptr_t *);
-extern bool ofw_sbus_apply_ranges(ofw_tree_node_t *, ofw_sbus_reg_t *,
-    uintptr_t *);
-extern bool ofw_upa_apply_ranges(ofw_tree_node_t *, ofw_upa_reg_t *,
-    uintptr_t *);
-
-extern bool ofw_pci_reg_absolutize(ofw_tree_node_t *, ofw_pci_reg_t *,
-    ofw_pci_reg_t *);
-
-extern bool ofw_fhc_map_interrupt(ofw_tree_node_t *, ofw_fhc_reg_t *,
-    uint32_t, int *, cir_t *, void **);
-extern bool ofw_ebus_map_interrupt(ofw_tree_node_t *, ofw_ebus_reg_t *,
-    uint32_t, int *, cir_t *, void **);
-extern bool ofw_pci_map_interrupt(ofw_tree_node_t *, ofw_pci_reg_t *,
-    int, int *, cir_t *, void **);
-
 #endif
Index: kernel/genarch/include/ofw/pci.h
===================================================================
--- kernel/genarch/include/ofw/pci.h	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
+++ kernel/genarch/include/ofw/pci.h	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -0,0 +1,64 @@
+/*
+ * Copyright (c) 2006 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef KERN_PCI_H_
+#define KERN_PCI_H_
+
+#include <genarch/ofw/ofw_tree.h>
+#include <arch/types.h>
+#include <ddi/irq.h>
+#include <typedefs.h>
+
+typedef struct {
+	/* Needs to be masked to obtain pure space id */
+	uint32_t space;
+	
+	/* Group phys.mid and phys.lo together */
+	uint64_t addr;
+	uint64_t size;
+} __attribute__ ((packed)) ofw_pci_reg_t;
+
+typedef struct {
+	uint32_t space;
+	
+	/* Group phys.mid and phys.lo together */
+	uint64_t child_base;
+	uint64_t parent_base;
+	uint64_t size;
+} __attribute__ ((packed)) ofw_pci_range_t;
+
+extern bool ofw_pci_apply_ranges(ofw_tree_node_t *, ofw_pci_reg_t *,
+    uintptr_t *);
+
+extern bool ofw_pci_reg_absolutize(ofw_tree_node_t *, ofw_pci_reg_t *,
+    ofw_pci_reg_t *);
+
+extern bool ofw_pci_map_interrupt(ofw_tree_node_t *, ofw_pci_reg_t *,
+    int, int *, cir_t *, void **);
+
+#endif
Index: kernel/genarch/include/ofw/sbus.h
===================================================================
--- kernel/genarch/include/ofw/sbus.h	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
+++ kernel/genarch/include/ofw/sbus.h	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -0,0 +1,51 @@
+/*
+ * Copyright (c) 2006 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef KERN_SBUS_H_
+#define KERN_SBUS_H_
+
+#include <genarch/ofw/ofw_tree.h>
+#include <arch/types.h>
+#include <ddi/irq.h>
+#include <typedefs.h>
+
+typedef struct {
+	uint64_t addr;
+	uint32_t size;
+} __attribute__ ((packed)) ofw_sbus_reg_t;
+
+typedef struct {
+	uint64_t child_base;
+	uint64_t parent_base;
+	uint32_t size;
+} __attribute__ ((packed)) ofw_sbus_range_t;
+
+extern bool ofw_sbus_apply_ranges(ofw_tree_node_t *, ofw_sbus_reg_t *,
+    uintptr_t *);
+
+#endif
Index: kernel/genarch/include/ofw/upa.h
===================================================================
--- kernel/genarch/include/ofw/upa.h	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
+++ kernel/genarch/include/ofw/upa.h	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -0,0 +1,45 @@
+/*
+ * Copyright (c) 2006 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef KERN_UPA_H_
+#define KERN_UPA_H_
+
+#include <genarch/ofw/ofw_tree.h>
+#include <arch/types.h>
+#include <ddi/irq.h>
+#include <typedefs.h>
+
+typedef struct {
+	uint64_t addr;
+	uint64_t size;
+} __attribute__ ((packed)) ofw_upa_reg_t;
+
+extern bool ofw_upa_apply_ranges(ofw_tree_node_t *, ofw_upa_reg_t *,
+    uintptr_t *);
+
+#endif
Index: kernel/genarch/src/drivers/dsrln/dsrlnout.c
===================================================================
--- kernel/genarch/src/drivers/dsrln/dsrlnout.c	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ kernel/genarch/src/drivers/dsrln/dsrlnout.c	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -66,5 +66,5 @@
 	
 	outdev_initialize("dsrlnout", &dsrlnout_console, &dsrlnout_ops);
-	stdout = &dsrlnout_console;
+	stdout_wire(&dsrlnout_console);
 	
 	sysinfo_set_item_val("fb", NULL, true);
Index: kernel/genarch/src/drivers/ega/ega.c
===================================================================
--- kernel/genarch/src/drivers/ega/ega.c	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ kernel/genarch/src/drivers/ega/ega.c	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -567,5 +567,5 @@
 	
 	outdev_initialize("ega", &ega_console, &ega_ops);
-	stdout = &ega_console;
+	stdout_wire(&ega_console);
 	
 	sysinfo_set_item_val("fb", NULL, true);
Index: kernel/genarch/src/fb/fb.c
===================================================================
--- kernel/genarch/src/fb/fb.c	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ kernel/genarch/src/fb/fb.c	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -458,6 +458,11 @@
  *
  */
-void fb_init(fb_properties_t *props)
-{
+bool fb_init(fb_properties_t *props)
+{
+	ASSERT(props);
+	ASSERT(props->x > 0);
+	ASSERT(props->y > 0);
+	ASSERT(props->scan > 0);
+	
 	switch (props->visual) {
 	case VISUAL_INDIRECT_8:
@@ -506,5 +511,6 @@
 		break;
 	default:
-		panic("Unsupported visual.");
+		LOG("Unsupported visual.");
+		return false;
 	}
 	
@@ -536,21 +542,33 @@
 	size_t glyphsize = FONT_GLYPHS * glyphbytes;
 	
+	fb_addr = (uint8_t *) hw_map((uintptr_t) props->addr, fbsize);
+	if (!fb_addr) {
+		LOG("Unable to map framebuffer.");
+		return false;
+	}
+	
 	backbuf = (uint16_t *) malloc(bbsize, 0);
-	if (!backbuf)
-		panic("Unable to allocate backbuffer.");
+	if (!backbuf) {
+		LOG("Unable to allocate backbuffer.");
+		return false;
+	}
 	
 	glyphs = (uint8_t *) malloc(glyphsize, 0);
-	if (!glyphs)
-		panic("Unable to allocate glyphs.");
+	if (!glyphs) {
+		free(backbuf);
+		LOG("Unable to allocate glyphs.");
+		return false;
+	}
 	
 	bgscan = malloc(bgscanbytes, 0);
-	if (!bgscan)
-		panic("Unable to allocate background pixel.");
+	if (!bgscan) {
+		free(glyphs);
+		free(backbuf);
+		LOG("Unable to allocate background pixel.");
+		return false;
+	}
 	
 	memsetw(backbuf, cols * rows, 0);
-	
 	glyphs_render();
-	
-	fb_addr = (uint8_t *) hw_map((uintptr_t) props->addr, fbsize);
 	
 	sysinfo_set_item_val("fb", NULL, true);
@@ -565,5 +583,7 @@
 	
 	outdev_initialize("fb", &fb_console, &fb_ops);
-	stdout = &fb_console;
+	stdout_wire(&fb_console);
+	
+	return true;
 }
 
Index: kernel/genarch/src/ofw/ebus.c
===================================================================
--- kernel/genarch/src/ofw/ebus.c	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ kernel/genarch/src/ofw/ebus.c	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -37,6 +37,7 @@
 
 #include <genarch/ofw/ofw_tree.h>
+#include <genarch/ofw/ebus.h>
+#include <genarch/ofw/pci.h>
 #include <arch/memstr.h>
-#include <arch/trap/interrupt.h>
 #include <string.h>
 #include <panic.h>
Index: kernel/genarch/src/ofw/fhc.c
===================================================================
--- kernel/genarch/src/ofw/fhc.c	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ kernel/genarch/src/ofw/fhc.c	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -37,4 +37,5 @@
 
 #include <genarch/ofw/ofw_tree.h>
+#include <genarch/ofw/fhc.h>
 #include <arch/drivers/fhc.h>
 #include <arch/memstr.h>
Index: kernel/genarch/src/ofw/ofw_tree.c
===================================================================
--- kernel/genarch/src/ofw/ofw_tree.c	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ kernel/genarch/src/ofw/ofw_tree.c	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -32,5 +32,5 @@
 /**
  * @file
- * @brief	OpenFirmware device tree navigation.
+ * @brief OpenFirmware device tree navigation.
  *
  */
@@ -40,9 +40,9 @@
 #include <mm/slab.h>
 #include <string.h>
+#include <panic.h>
 #include <print.h>
-#include <panic.h>
-
-#define PATH_MAX_LEN	80
-#define NAME_BUF_LEN	50
+
+#define PATH_MAX_LEN  256
+#define NAME_BUF_LEN  50
 
 static ofw_tree_node_t *ofw_root;
@@ -55,12 +55,13 @@
 /** Get OpenFirmware node property.
  *
- * @param node		Node in which to lookup the property.
- * @param name		Name of the property.
- *
- * @return		Pointer to the property structure or NULL if no such
- * 			property.
- */
-ofw_tree_property_t *
-ofw_tree_getprop(const ofw_tree_node_t *node, const char *name)
+ * @param node Node in which to lookup the property.
+ * @param name Name of the property.
+ *
+ * @return Pointer to the property structure or NULL if no such
+ *         property.
+ *
+ */
+ofw_tree_property_t *ofw_tree_getprop(const ofw_tree_node_t *node,
+    const char *name)
 {
 	unsigned int i;
@@ -70,5 +71,5 @@
 			return &node->property[i];
 	}
-
+	
 	return NULL;
 }
@@ -76,18 +77,15 @@
 /** Return value of the 'name' property.
  *
- * @param node		Node of interest.
- *
- * @return		Value of the 'name' property belonging to the node.
+ * @param node Node of interest.
+ *
+ * @return Value of the 'name' property belonging to the node
+ *         or NULL if the property is invalid.
+ *
  */
 const char *ofw_tree_node_name(const ofw_tree_node_t *node)
 {
-	ofw_tree_property_t *prop;
-	
-	prop = ofw_tree_getprop(node, "name");
-	if (!prop)
-		panic("Node without name property.");
-		
-	if (prop->size < 2)
-		panic("Invalid name property.");
+	ofw_tree_property_t *prop = ofw_tree_getprop(node, "name");
+	if ((!prop) || (prop->size < 2))
+		return NULL;
 	
 	return prop->value;
@@ -96,11 +94,13 @@
 /** Lookup child of given name.
  *
- * @param node		Node whose child is being looked up.
- * @param name		Name of the child being looked up.
- *
- * @return		NULL if there is no such child or pointer to the
- * 			matching child node.
- */
-ofw_tree_node_t *ofw_tree_find_child(ofw_tree_node_t *node, const char *name)
+ * @param node Node whose child is being looked up.
+ * @param name Name of the child being looked up.
+ *
+ * @return NULL if there is no such child or pointer to the
+ *         matching child node.
+ *
+ */
+ofw_tree_node_t *ofw_tree_find_child(ofw_tree_node_t *node,
+    const char *name)
 {
 	ofw_tree_node_t *cur;
@@ -125,5 +125,5 @@
 			return cur;
 	}
-		
+	
 	return NULL;
 }
@@ -131,24 +131,27 @@
 /** Lookup first child of given device type.
  *
- * @param node		Node whose child is being looked up.
- * @param name		Device type of the child being looked up.
- *
- * @return		NULL if there is no such child or pointer to the
- * 			matching child node.
- */
-ofw_tree_node_t *
-ofw_tree_find_child_by_device_type(ofw_tree_node_t *node, const char *name)
-{
-	ofw_tree_node_t *cur;
-	ofw_tree_property_t *prop;
+ * @param node  Node whose child is being looked up.
+ * @param dtype Device type of the child being looked up.
+ *
+ * @return NULL if there is no such child or pointer to the
+ *         matching child node.
+ *
+ */
+ofw_tree_node_t *ofw_tree_find_child_by_device_type(ofw_tree_node_t *node,
+    const char *dtype)
+{
+	ofw_tree_node_t *cur;
 	
 	for (cur = node->child; cur; cur = cur->peer) {
-		prop = ofw_tree_getprop(cur, "device_type");
-		if (!prop || !prop->value)
+		ofw_tree_property_t *prop =
+		    ofw_tree_getprop(cur, "device_type");
+		
+		if ((!prop) || (!prop->value))
 			continue;
-		if (str_cmp(prop->value, name) == 0)
-			return cur;
-	}
-			
+		
+		if (str_cmp(prop->value, dtype) == 0)
+			return cur;
+	}
+	
 	return NULL;
 }
@@ -159,23 +162,23 @@
  * are looked up iteratively to avoid stack overflow.
  *
- * @param root		Root of the searched subtree.
- * @param handle	OpenFirmware handle.
- *
- * @return		NULL if there is no such node or pointer to the matching
- * 			node.
- */
-ofw_tree_node_t *
-ofw_tree_find_node_by_handle(ofw_tree_node_t *root, uint32_t handle)
-{
-	ofw_tree_node_t *cur;
-
-	for (cur = root; cur; cur = cur->peer) {		
+ * @param root   Root of the searched subtree.
+ * @param handle OpenFirmware handle.
+ *
+ * @return NULL if there is no such node or pointer to the matching
+ *         node.
+ *
+ */
+ofw_tree_node_t *ofw_tree_find_node_by_handle(ofw_tree_node_t *root,
+    uint32_t handle)
+{
+	ofw_tree_node_t *cur;
+	
+	for (cur = root; cur; cur = cur->peer) {
 		if (cur->node_handle == handle)
 			return cur;
-
+		
 		if (cur->child) {
-			ofw_tree_node_t *node;
-			
-			node = ofw_tree_find_node_by_handle(cur->child, handle);
+			ofw_tree_node_t *node
+			    = ofw_tree_find_node_by_handle(cur->child, handle);
 			if (node)
 				return node;
@@ -183,55 +186,60 @@
 	}
 	
-	return NULL;	
+	return NULL;
 }
 
 /** Lookup first peer of given device type.
  *
- * @param node		Node whose peer is being looked up.
- * @param name		Device type of the child being looked up.
- *
- * @return		NULL if there is no such child or pointer to the
- * 			matching child node.
- */
-ofw_tree_node_t *
-ofw_tree_find_peer_by_device_type(ofw_tree_node_t *node, const char *name)
-{
-	ofw_tree_node_t *cur;
-	ofw_tree_property_t *prop;
+ * @param node  Node whose peer is being looked up.
+ * @param dtype Device type of the child being looked up.
+ *
+ * @return NULL if there is no such child or pointer to the
+ *         matching child node.
+ *
+ */
+ofw_tree_node_t *ofw_tree_find_peer_by_device_type(ofw_tree_node_t *node,
+    const char *dtype)
+{
+	ofw_tree_node_t *cur;
 	
 	for (cur = node->peer; cur; cur = cur->peer) {
-		prop = ofw_tree_getprop(cur, "device_type");
-		if (!prop || !prop->value)
+		ofw_tree_property_t *prop =
+		    ofw_tree_getprop(cur, "device_type");
+		
+		if ((!prop) || (!prop->value))
 			continue;
+		
+		if (str_cmp(prop->value, dtype) == 0)
+			return cur;
+	}
+	
+	return NULL;
+}
+
+/** Lookup first peer of given name.
+ *
+ * @param node Node whose peer is being looked up.
+ * @param name Name of the child being looked up.
+ *
+ * @return NULL if there is no such peer or pointer to the matching
+ *         peer node.
+ *
+ */
+ofw_tree_node_t *ofw_tree_find_peer_by_name(ofw_tree_node_t *node,
+    const char *name)
+{
+	ofw_tree_node_t *cur;
+	
+	for (cur = node->peer; cur; cur = cur->peer) {
+		ofw_tree_property_t *prop
+		    = ofw_tree_getprop(cur, "name");
+		
+		if ((!prop) || (!prop->value))
+			continue;
+		
 		if (str_cmp(prop->value, name) == 0)
 			return cur;
 	}
-			
-	return NULL;
-}
-
-
-/** Lookup first peer of given name.
- *
- * @param node		Node whose peer is being looked up.
- * @param name		Name of the child being looked up.
- *
- * @return		NULL if there is no such peer or pointer to the matching
- * 			peer node.
- */
-ofw_tree_node_t *
-ofw_tree_find_peer_by_name(ofw_tree_node_t *node, const char *name)
-{
-	ofw_tree_node_t *cur;
-	ofw_tree_property_t *prop;
-	
-	for (cur = node->peer; cur; cur = cur->peer) {
-		prop = ofw_tree_getprop(cur, "name");
-		if (!prop || !prop->value)
-			continue;
-		if (str_cmp(prop->value, name) == 0)
-			return cur;
-	}
-			
+	
 	return NULL;
 }
@@ -239,19 +247,19 @@
 /** Lookup OpenFirmware node by its path.
  *
- * @param path		Path to the node.
- *
- * @return		NULL if there is no such node or pointer to the leaf
- * 			node.
+ * @param path Path to the node.
+ *
+ * @return NULL if there is no such node or pointer to the leaf
+ *         node.
+ *
  */
 ofw_tree_node_t *ofw_tree_lookup(const char *path)
 {
-	char buf[NAME_BUF_LEN + 1];
+	if (path[0] != '/')
+		return NULL;
+	
 	ofw_tree_node_t *node = ofw_root;
 	size_t i;
 	size_t j;
 	
-	if (path[0] != '/')
-		return NULL;
-	
 	for (i = 1; (i < str_size(path)) && (node); i = j + 1) {
 		for (j = i; (j < str_size(path)) && (path[j] != '/'); j++);
@@ -261,4 +269,5 @@
 			continue;
 		
+		char buf[NAME_BUF_LEN + 1];
 		memcpy(buf, &path[i], j - i);
 		buf[j - i] = 0;
@@ -269,33 +278,88 @@
 }
 
-/** Print OpenFirmware device subtree rooted in a node.
+/** Walk the OpenFirmware device subtree rooted in a node.
  *
  * Child nodes are processed recursively and peer nodes are processed
  * iteratively in order to avoid stack overflow.
  *
- * @param node		Root of the subtree.
- * @param path		Current path, NULL for the very root of the entire tree.
- */
-static void ofw_tree_node_print(const ofw_tree_node_t *node, const char *path)
-{
-	char *p;
-	const ofw_tree_node_t *cur;
-
-	p = (char *) malloc(PATH_MAX_LEN, 0);
-
+ * @param node   Root of the subtree.
+ * @param dtype  Device type to look for.
+ * @param walker Routine to be invoked on found device.
+ * @param arg    User argument to the walker.
+ *
+ * @return True if the walk should continue.
+ *
+ */
+static bool ofw_tree_walk_by_device_type_internal(ofw_tree_node_t *node,
+    const char *dtype, ofw_tree_walker_t walker, void *arg)
+{
+	ofw_tree_node_t *cur;
+	
 	for (cur = node; cur; cur = cur->peer) {
-		if (cur->parent) {
-			snprintf(p, PATH_MAX_LEN, "%s/%s", path, cur->da_name);
-			printf("%s\n", p);
+		ofw_tree_property_t *prop =
+		    ofw_tree_getprop(cur, "device_type");
+		
+		if ((prop) && (prop->value) && (str_cmp(prop->value, dtype) == 0)) {
+			bool ret = walker(cur, arg);
+			if (!ret)
+				return false;
+		}
+		
+		if (cur->child) {
+			bool ret =
+			    ofw_tree_walk_by_device_type_internal(cur->child, dtype, walker, arg);
+			if (!ret)
+				return false;
+		}
+	}
+	
+	return true;
+}
+
+/** Walk the OpenFirmware device tree and find devices by type.
+ *
+ * Walk the whole OpenFirmware device tree and if any node has
+ * the property "device_type" equal to dtype, run a walker on it.
+ * If the walker returns false, the walk does not continue.
+ *
+ * @param dtype  Device type to look for.
+ * @param walker Routine to be invoked on found device.
+ * @param arg    User argument to the walker.
+ *
+ */
+void ofw_tree_walk_by_device_type(const char *dtype, ofw_tree_walker_t walker,
+    void *arg)
+{
+	(void) ofw_tree_walk_by_device_type_internal(ofw_root, dtype, walker, arg);
+}
+
+/** Print OpenFirmware device subtree rooted in a node.
+ *
+ * Child nodes are processed recursively and peer nodes are processed
+ * iteratively in order to avoid stack overflow.
+ *
+ * @param node Root of the subtree.
+ * @param path Current path, NULL for the very root of the entire tree.
+ *
+ */
+static void ofw_tree_node_print(ofw_tree_node_t *node, const char *path)
+{
+	char *cur_path = (char *) malloc(PATH_MAX_LEN, 0);
+	ofw_tree_node_t *cur;
+	
+	for (cur = node; cur; cur = cur->peer) {
+		if ((cur->parent) && (path)) {
+			snprintf(cur_path, PATH_MAX_LEN, "%s/%s", path, cur->da_name);
+			printf("%s\n", cur_path);
 		} else {
-			snprintf(p, PATH_MAX_LEN, "%s", cur->da_name);
+			snprintf(cur_path, PATH_MAX_LEN, "%s", cur->da_name);
 			printf("/\n");
 		}
-
+		
 		if (cur->child)
-			ofw_tree_node_print(cur->child, p);
-	}
-
-	free(p);
+			ofw_tree_node_print(cur->child, cur_path);
+	}
+	
+	free(cur_path);
 }
 
Index: kernel/genarch/src/ofw/pci.c
===================================================================
--- kernel/genarch/src/ofw/pci.c	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ kernel/genarch/src/ofw/pci.c	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -37,4 +37,5 @@
 
 #include <genarch/ofw/ofw_tree.h>
+#include <genarch/ofw/pci.h>
 #include <arch/drivers/pci.h>
 #include <arch/trap/interrupt.h>
Index: kernel/genarch/src/ofw/sbus.c
===================================================================
--- kernel/genarch/src/ofw/sbus.c	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ kernel/genarch/src/ofw/sbus.c	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -37,4 +37,5 @@
 
 #include <genarch/ofw/ofw_tree.h>
+#include <genarch/ofw/sbus.h>
 #include <macros.h>
 
Index: kernel/genarch/src/ofw/upa.c
===================================================================
--- kernel/genarch/src/ofw/upa.c	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ kernel/genarch/src/ofw/upa.c	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -37,4 +37,5 @@
 
 #include <genarch/ofw/ofw_tree.h>
+#include <genarch/ofw/upa.h>
 #include <arch/memstr.h>
 #include <func.h>
Index: kernel/generic/include/console/chardev.h
===================================================================
--- kernel/generic/include/console/chardev.h	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ kernel/generic/include/console/chardev.h	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -36,4 +36,5 @@
 #define KERN_CHARDEV_H_
 
+#include <adt/list.h>
 #include <arch/types.h>
 #include <synch/waitq.h>
@@ -75,5 +76,5 @@
 } outdev_operations_t;
 
-/** Character input device. */
+/** Character output device. */
 typedef struct outdev {
 	char *name;
@@ -81,4 +82,8 @@
 	/** Protects everything below. */
 	SPINLOCK_DECLARE(lock);
+	
+	/** Fields suitable for multiplexing. */
+	link_t link;
+	link_t list;
 	
 	/** Implementation of outdev operations. */
Index: kernel/generic/include/console/console.h
===================================================================
--- kernel/generic/include/console/console.h	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ kernel/generic/include/console/console.h	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -44,4 +44,5 @@
 
 extern indev_t *stdin_wire(void);
+extern void stdout_wire(outdev_t *outdev);
 extern void console_init(void);
 
Index: kernel/generic/src/console/chardev.c
===================================================================
--- kernel/generic/src/console/chardev.c	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ kernel/generic/src/console/chardev.c	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -33,4 +33,5 @@
  */
 
+#include <adt/list.h>
 #include <console/chardev.h>
 #include <synch/waitq.h>
@@ -134,4 +135,6 @@
 	outdev->name = name;
 	spinlock_initialize(&outdev->lock, "outdev");
+	link_initialize(&outdev->link);
+	list_initialize(&outdev->list);
 	outdev->op = op;
 }
